"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.inputQuerySchema = void 0;
const inputQuerySchemaJson = require("../schema/input-query-schema.json");
function inputQuerySchema(entity, fieldsArray, relationsField, schemaName) {
    const json = JSON.parse(JSON.stringify(inputQuerySchemaJson));
    const relationsFieldSchema = Object.keys(relationsField).reduce((acum, item) => {
        acum[item] = {
            type: 'string',
        };
        return acum;
    }, {});
    const linkFilter = {
        oneOf: [
            {
                type: 'string',
            },
            {
                $ref: `#/$defs/operand`,
            },
        ],
    };
    const linkFilterRelationField = {
        oneOf: [
            {
                type: 'string',
            },
            {
                $ref: `#/$defs/operandForRelationProps`,
            },
        ],
    };
    const fieldsFilterSchema = [
        ...fieldsArray,
        ...Object.keys(relationsField),
    ].reduce((acum, i) => ((acum[i] = linkFilter), acum), {});
    const relationFilterSchema = Object.entries(relationsField).reduce((acum, [key, val]) => {
        const relationFilter = val.reduce((a, i) => ((a[`${key}.${i}`] = linkFilterRelationField), a), acum);
        return val.reduce((a, i) => ((a[`${key}.${i}`] = linkFilter), a), relationFilter);
    }, {});
    json.$id = `${json.$id}/${schemaName}`;
    json.properties.fields['properties'] = Object.assign(Object.assign(Object.assign({}, json.properties.fields['properties']), {
        target: {
            type: 'string',
        },
    }), relationsFieldSchema);
    json.properties.filter['properties'] = Object.assign(Object.assign(Object.assign({}, json.properties.filter['properties']), fieldsFilterSchema), relationFilterSchema);
    return json;
}
exports.inputQuerySchema = inputQuerySchema;
//# sourceMappingURL=input-query-schema.js.map